% COMMON_PRE  (Example-10: Modeling Cigarette Smokers' Problem)
% Reggie.davidrajuh@uis.no  (c) 03 March 2023

function [fire, transition] = COMMON_PRE (transition)
 
if ismember(transition.name, {'tAdmin', 'tColorTag'})
    % tAdmin and tColorTag have their own pre-processors
    fire = 1; return
end
 
switch transition.name
    case 'tTO'
        % tTO select tokens with color 'Wrapping-Paper' or 'Matches'
        tokID1 = tokenAllColor('pReady',1, {'Wrapping-Paper'});
        tokID2 = tokenAllColor('pReady',1, {'Matches'});
        tokIDs = [tokID1, tokID2];
        
    case 'tWR'
        % tWR select tokens with color 'Tobacco' or 'Matches'
        tokID1 = tokenAllColor('pReady',1, {'Tobacco'});
        tokID2 = tokenAllColor('pReady',1, {'Matches'});
        tokIDs = [tokID1, tokID2];
        
    case 'tMA'
        % tMA selects tokens with color 'Tobacco' or 'Wrapping-Paper'
        tokID1 = tokenAllColor('pReady',1, {'Tobacco'});
        tokID2 = tokenAllColor('pReady',1, {'Wrapping-Paper'});
        tokIDs = [tokID1, tokID2];        
    otherwise
        errormsg([transition.name, 'what is this transition? ']);
end
 
transition.selected_tokens = tokIDs;
fire = all(tokIDs);