% Sample code from the book: "Colored Petri Nets for 
% Modeling of Discrete Systems: A practical approach with GPenSIM"
% 
% Example-10: MSF (Modeling Cigarette Smokers' Problem)
%             Colored Petri Net model
% Reggie.davidrajuh@uis.no  (c) 03 March 2023

clear all; clc; 
global global_info          
global_info.STOP_AT = 50;  % 
global_info.SUPPLIES={'Tobacco','Matches','Wrapping-Paper'};%
global_info.MAX_NUMBER_OF_CIGARETTES = 3; % cigarettes to be smoked
global_info.cigarette_counter = 0; % smoked cigarettes so far

pns = pnstruct('csp_color_pdf');
dyn.m0 = {'pAdmin',1}; % just to start 
dyn.ft = {'allothers',1}; % all transitons take 1 TU
pni = initialdynamics(pns, dyn);
 
sim = gpensim(pni);
prnfinalcolors(sim, {'pMASmoked', 'pTOSmoked', 'pWRSmoked'});